R.<q> = PolynomialRing(ZZ, 1)
HD4 = IwahoriHeckeAlgebra('D4', 1, -q, R)
T = HD4.T()
D4 = WeylGroup('D4')
w0D4 = D4.w0
jelt = w0D4*D4.from_reduced_word([1,2,3,1,2,1])
JM_redex = jelt.reduced_word()
print JM_redex
print len(JM_redex)

def T_elt_from_list(expr):
    result = 1
    for index in expr:
        result = result*T[index]
    return result    

def add_term(dic, key, value):
    if key in dic:
        dic[key] += value
    else:
        dic[key] = value

#returns a dictionary whose keys are the w so that T_w appears in T[redex_1]*T[redex_2] and whose values are the corresponding coefficients
def coef_dictionary(redex_1, redex_2):
    result = {}
    result[D4.from_reduced_word(redex_1)] = 1
    redex_2_length = len(redex_2)
    for i in range(redex_2_length):
        print 'iteration' + str(i) + 'of' + str(redex_2_length)
        temp = {}
        j = 0
        result_length = len(result)
        for elt in result:
            j +=1
            print 'calculation' + str(j) + 'of' + str(result_length)
            prod_elt = D4.simple_reflection(redex_2[i])*elt
            if prod_elt.length() > elt.length():
                add_term(temp, prod_elt, result[elt])
            else:
                add_term(temp, prod_elt, q*result[elt])
                add_term(temp, elt, (1 - q)*result[elt])
        result.clear()
        result = temp
    return result

#works better if dic is smaller than A3
def faster_reduce_to_A3(dic):
    result = {}
    for elt in dic:
        translated_elt = elt*jelt
        redex = translated_elt.reduced_word()
        if 4 not in redex:#MAKE SURE TO CHANGE THIS IF YOU CHANGE GROUPS
            result[translated_elt] = dic[elt]
    return result

#removes all key, value pairs such that key has length less than min_length
def trim(dic, min_length):
    print 'trimming: initial size ' + str(len(dic))
    new_dic = {}
    for elt in dic:
        if elt.length() >= min_length:
            new_dic[elt] = dic[elt]
    dic = new_dic
    print 'after trimming: final size ' + str(len(dic))
    return dic

#same as coef_dictionary, but after the half way point every 1 in freq right
#multiplications is followed by a “trimming”, meaning terms which are too short
#are deleted from the dictionary.  Trimming is a bit expensive, so it’s not clear
#what value of freq will create the best (or any) savings
def coef_dictionary_with_trimming(redex_1, redex_2, freq):
    result = {}
    result[D4.from_reduced_word(redex_1)] = 1
    redex_2_length = len(redex_2)
    for i in range(redex_2_length):
        print 'iteration' + str(i) + 'of' + str(redex_2_length)
        temp = {}
        result_length = len(result)
        print 'calculation of size ' + str(result_length) + 'coming'
        for elt in result:
            prod_elt = D4.simple_reflection(redex_2[i])*elt
            if prod_elt.length() > elt.length():
                add_term(temp, prod_elt, result[elt])
            else:
                add_term(temp, prod_elt, q*result[elt])
                add_term(temp, elt, (1 - q)*result[elt])
        result.clear()
        if i > (redex_2_length + 1)/2 and i % freq == 0:
            temp = trim(temp, i)#redex_2_length - i calcs left, so only include length >=i
        result = temp
    return result