R.<q> = PolynomialRing(ZZ, 1)
W_big = WeylGroup('E8')
W_small = WeylGroup('D7')
w0W_big = W_big.w0
w0W_small = W_big.from_reduced_word([9 - i for i in W_small.w0.reduced_word()])
MISSING_INDEX = 1
REMAINING_INDEXES = [2,3,4,5,6,7,8]
jelt = w0W_big*w0W_small
JM_redex = jelt.reduced_word()
JM_redex_length = len(JM_redex)

def left_reduce_one_step(elt):
    for i in REMAINING_INDEXES:
        if elt.has_left_descent(i):
            return W_big.simple_reflection(i)*elt
    return elt

def left_reduce(elt):
    temp = left_reduce_one_step(elt)
    while temp != elt:
        elt = temp
        temp = left_reduce_one_step(elt)
    return temp

def add_term(dic, key, value):
    key = left_reduce(key)
    if key in dic:
        dic[key] += value
    else:
        dic[key] = value

def do_multiplication():
    coef_dic = {}
    coef_dic[jelt] = 1
    for i, curr_index in enumerate(JM_redex):
        temp_dic = {}
        print "iteration ", i, " of ", JM_redex_length
        print "working with dictionary of size: ", len(coef_dic)
        for elt in coef_dic:
            elt_times_s = elt*W_big.simple_reflection(curr_index)
            coef = coef_dic[elt]
            if elt.has_right_descent(curr_index):#so mult was length decreasing
                add_term(temp_dic, elt, (1 - q)*coef)
                add_term(temp_dic, elt_times_s, q*coef)
            else:#so mult was length increasing
                add_term(temp_dic, elt_times_s, coef)
        coef_dic.clear()
        coef_dic = temp_dic
    return coef_dic

coef_dic = do_multiplication()
print "sum of coefficients is: ", coef_dic[jelt]